package ps4;

/**
 * The Add filter "adds" together images with logical OR.
 * This filter applies to multiple images.
 * @author Daniel Marcus
 */

public class AddFilter extends MultiFilter {
	private static final long serialVersionUID = 1L;

	protected void filter()
	// MODIFIES: this
	// EFFECTS: Replaces each pixel in the image with the bitwise or of
	//    it and the corresponding pixel in 
	{
		int r, g, b;
		int width = getMinimumWidth();
		int height = getMinimumHeight();
		
		for(int col = 0; col < width; col++) {
			for(int row = 0; row < height; row++) {	
				r = getRed(row, col);
				g = getGreen(row, col);
				b = getBlue(row, col);
				
				for(int i = 0; i < getNumberSecondary(); i++) {
					Pixels pimage = getImagePixels(i);
					r = r | pimage.getRed(row, col);
					g = g | pimage.getGreen(row, col);
					b = b | pimage.getBlue(row, col);
				}
				
				setColors(row, col, r, g, b);
			}
		}
	}
		
	public String getFilterName()
	{
		return "add";
	}
}

