package ps4;

/**
 * The Flip filter horizontally flips the image.
 * This filter applies to a single image.
 * @author Kei Sakaguchi
 */

public class FlipFilter extends Filter {
	private static final long serialVersionUID = 1L;

	protected void filter()
	// MODIFIES: this
	// EFFECTS: Replaces the pixels in image with their mirror image
	//             (flips horizontally around center).
	{	
		// need temp to store the new image values so originals are not overwritten
		Pixels temp = new Pixels(pixels);
		int pwidth = pixels.getWidth() - 1;
		for (int row = 0; row < pixels.getHeight(); row++) {
			for (int col = 0; col < pixels.getWidth(); col++) {
				temp.setColor(row, pwidth - col, getColor(row,col));
			}
		}

		pixels = temp;
	}
	
	public String getFilterName() {
		return "flip";
	}

}
