package ps4;
import java.awt.Color;

/**
 * The Greyscale filter converts the image to shades of grey.
 * @author Kei Sakaguchi and Daniel Marcus
 */

public class GreyscaleFilter extends PointFilter {
	private static final long serialVersionUID = 1L;

	@Override
	protected Color filterPoint(Color p_c)
	{		
		int grey = getGrey(p_c);
		return new Color (grey, grey, grey);
	}
	
	protected static int getGrey(Color p_c)
	// EFFECTS: Returns the greyscale color corresponding to color p_c.
	//     Corrects for human color recognition and streches to 255.
	{
		double grey = (0.77 * p_c.getRed()) + (1.51 * p_c.getGreen()) + (0.28 * p_c.getBlue());
		grey = (grey / 3) / 0.8533;
		return (int) grey;
	}
	
	public String getFilterName() {
		return "greyscale";
	}
}
