package ps4;

import java.awt.Color;

public abstract class PointFilter extends Filter {
	// OVERVIEW: A PointFilter is a filter that can be performed by
	//     altering points independently.
	
	protected abstract Color filterPoint(Color p_c);
	// EFFECTS: Returns the new color for a pixel with current color c.

	final protected void filter()
	// EFFECTS: Sets the new color of each point in the image to the
        //    result of filterPoint on the current color.
	//    Note: final method, cannot be overridden 
	{		
		for (int row = 0; row < getImageHeight(); row++) {
			for (int col = 0; col < getImageWidth(); col++) {
				setColor (row, col, filterPoint(getColor (row,col)));
			}
		}
	}
}
