	// Thumbnail.java
// Code based on Macro Schmidt's thumbnail code
// from http://schmidt.devlib.org/java/save-jpeg-thumbnail.html

package ps4;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;

public class Thumbnail {
	// for the curious, getThumbImage() code from:
	// 

	static public Image getScaledImage(Image image, int scaledWidth,
			int scaledHeight)
	// REQUIRES: scaledWidth > 0 and scaledHeight > 0 and image != null
	{
		assert scaledWidth > 0;
		assert scaledHeight > 0;
		assert image != null;
		
		int imageWidth = image.getWidth(null);
		int imageHeight = image.getHeight(null);

		double imageRatio = (double) imageWidth / (double) imageHeight;
		double scaledRatio = (double) scaledWidth / (double) scaledHeight;

		if (imageRatio > scaledRatio)
			scaledHeight = (int) ((double) scaledWidth / imageRatio);
		else
			scaledWidth = (int) ((double) scaledHeight * imageRatio);

		assert scaledWidth > 0;
		assert scaledHeight > 0;

		try {
			BufferedImage scaledImage = new BufferedImage(scaledWidth,
					scaledHeight, BufferedImage.TYPE_INT_RGB);
			Graphics2D graphics2D = scaledImage.createGraphics();
			graphics2D.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
					RenderingHints.VALUE_INTERPOLATION_BILINEAR);
			graphics2D.drawImage(image, 0, 0, scaledWidth, scaledHeight, null);
			return scaledImage;
		} catch (Exception e) {
			System.err.println("Exception: " + e);
			return image;
		}
	}
}
