package ps4;

public class TileFilter extends MultiFilter {
	private static final long serialVersionUID = 1L;
	
	private int tileSize = 12;
	
	public String getFilterName()
	{
		return "tile";
	}
	
	protected void filter()
	// MODIFIES: this
	// EFFECTS: Modifies the image by tiling the primary image and secondary images.
	{
		int width = getMinimumWidth();
		int height = getMinimumHeight();
		int numimages = 1 + getNumberSecondary();
		
		for(int col = 0; col < width; col++) {
			for(int row = 0; row < height; row++) {
				int imgno = ((col / tileSize) + (row / tileSize)) % numimages;
				if (imgno != 0) {
					Pixels pimage = getImagePixels(imgno - 1);
					setColors(row, col, pimage.getRed(row, col), pimage.getGreen(row, col), pimage.getBlue(row, col));
				}
			}
		}
	}	
}
